<?php

/**
 * Implements hook_views_arguments_any_field__VIEW__DISPLAY__FIELD().
 *
 * Depending on FIELD, you know what kind of entity $entity is (node, user etc).
 *
 * Valid function names could be:
 * - hook_views_arguments_any_field__admin_node_content__default__any_node
 * - hook_views_arguments_any_field__fav_content__page__any_user_1  (2nd 'any_user' field)
 * - etc. 'FIELD' will always have a format like 'any_ENTITY_TYPE[_N]'
 *
 * $context contains
 * - 'handler' - the views field handler, which contains ->view, ->query etc
 * - 'values' - the db record for this row, maybe with 'nid' or 'uid' or something
 */
function hook_views_arguments_any_field__VIEW__DISPLAY__FIELD($entity, $context) {
  // Any $entity could do this:
  $magic = new MyMagic($entity);
  $magic->calculateStuff(menu_get_object());
  $html = $magic->renderStuff();
  return $html;

  // A $node could do this to show its enabled domains:
  $dids = $node->domains;
  $domains = domain_load_multiple($dids); // I wish
  $domain_names = array_map(function($domain) {
    return $domain['name'];
  }, $domains);
  return check_plain(implode(', ', $domain_names));

  // A $user could show the IP address of the hostname of its init mail:
  $components = explode('@', $user->init);
  $hostname = $components[1];
  $ip = gethostbyname($hostname);
  return $ip;
}

/**
 * Implements views:default_argument:from_callback.
 *
 * ^ That comment is important! ^
 *
 * Any custom callback that returns an argument value of any type, depending
 * on which argument uses this default.
 *
 * This is not really a hook hook, hence 'YOUR_MODULE' instead of 'hook'.
 */
function YOUR_MODULE_custom_tid_callback_or_something($view, $handler) {
  if (preg_match('#^node/(\d+)/special$#', current_path(), $match)) {
    if ($node = node_load($match[1])) {
      $items = field_get_items('node', $node, 'field_special_term');
      if ($items) {
        return $items[0]['tid'];
      }
    }
  }
}
